/*
Fit - quation / nuage de points  la main, avec les flches

Copyright (C) 2003 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.URL;
import java.util.ResourceBundle;

import ptolemy.plot.plotml.PlotMLParser;
import ptolemy.plot.PlotApplet;
import ptolemy.plot.Plot;
import ptolemy.plot.PlotBox;

import com.microstar.xml.XmlException;


public class Fit extends PlotApplet {

    static ResourceBundle rb  = ResourceBundle.getBundle("LocalStrings");
    
    boolean inverserY = true; // inverse l'axe des Y

    Label deltal = new Label("cliquer sur le graphe puis utiliser les flches pour dplacer le nuage de points");

    public void init() {
        super.init();
        add(deltal, BorderLayout.SOUTH);
        
        ((FitPlot)plot()).requestFocus();
    }
    
    protected void ajouterEquation() {
        // ZAMS en (B-V)0 de -0,4  1,4 (Mv de -4,0  7,0)
        double x1 = -0.4;
        double x2 = 1.4;
        int npts = 50; // nombre de points utiliss pour la courbe
        boolean connected = true;
        int ndataset = ((Plot)plot()).getNumDataSets();
        //System.out.println("nombre d'ensembles: " + ndataset);
        ((Plot)plot()).setConnected(true);
        ((Plot)plot()).addLegend(ndataset, "ZAMS");
        ((Plot)plot()).setMarksStyle("none",ndataset);
        for (int i=0; i<=npts; i++) {
            double x = x1 + ((x2-x1)*i)/npts;
            double y = 4.900956
                + 3.963022 * (x/0.6-1)
                - 1.945610 * Math.pow((x/0.6-1), 2)
                - 2.387670 * Math.pow((x/0.6-1), 3)
                + 4.926864 * Math.pow((x/0.6-1), 4)
                + 1.852996 * Math.pow((x/0.6-1), 5)
                - 5.092483 * Math.pow((x/0.6-1), 6)
                - 0.391999 * Math.pow((x/0.6-1), 7)
                + 2.084633 * Math.pow((x/0.6-1), 8)
                + 0.019847 * Math.pow((x/0.6-1), 9)
                - 0.315203 * Math.pow((x/0.6-1),10);
            if (inverserY)
                y = -y;
            ((Plot)plot()).addPoint(ndataset, x, y, connected);
        }
    }
    
    /** Read the specified stream.  This method checks to see whether
     *  the data is PlotML data, and if so, creates a parser to read it.
     *  If not, it defers to the parent class to read it.
     *  @param in The input stream.
     *  @exception IOException If the stream cannot be read.
     */
    protected void _read(InputStream in) throws IOException {
        // Create a buffered input stream so that mark and reset
        // are supported.
        BufferedInputStream bin = new BufferedInputStream(in);
        // Peek at the file...
        bin.mark(9);
        // Read 8 bytes in case 16-bit encoding is being used.
        byte[] peek = new byte[8];
        bin.read(peek);
        bin.reset();
        if ((new String(peek)).startsWith("<?xm")) {
            // file is an XML file.
            PlotMLParser parser = _newParser();
            try {
                URL docBase = getDocumentBase();
                parser.parse(docBase, bin);
            } catch (Exception ex) {
                String msg;
                if (ex instanceof XmlException) {
                    XmlException xmlex = (XmlException)ex;
                    msg =
                        "PlotMLApplet: failed to parse PlotML data:\n"
                        + "line: " + xmlex.getLine()
                        + ", column: " + xmlex.getColumn()
                        + "\nIn entity: " + xmlex.getSystemId()
                        + "\n";
                } else {
                    msg = "PlotMLApplet: failed to parse PlotML data:\n";
                }
                System.err.println(msg + ex.toString());
                ex.printStackTrace();
            }
        } else {
            super._read(bin);
        }
        
        ajouterEquation();
        if (inverserY) {
            double[][] data = ((FitPlot)plot()).getData(0);
            for (int i=0; i<data[0].length; i++) {
                data[1][i] = -data[1][i];
            }
            ((FitPlot)plot()).setData(0, data);
            ((FitPlot)plot()).recalcZone();
            
            for (int i=-20; i<20; i++)
                (plot()).addYTick(""+(-i), i);
        }
    }
    
    /** Create a new parser object for the applet.  Derived classes can
     *  redefine this method to return a different type of parser.
     */
    protected PlotMLParser _newParser() {
        return new PlotMLParser((Plot)plot());
    }
    
    public PlotBox newPlot() {
        return new FitPlot(deltal);
    }
    
    protected void _setPlotSize(int appletWidth, int appletHeight) {
        plot().setSize(appletWidth, appletHeight-20);
    }
    
}
